git-stash.shon commit Merge branch 'ls/travis-scriptify' into maint (a37b73e)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
  11                      [-u|--include-untracked] [-a|--all] [<message>]
  12   or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
  13                       [-u|--include-untracked] [-a|--all] [-m <message>]
  14                       [-- <pathspec>...]]
  15   or: $dashless clear"
  16
  17SUBDIRECTORY_OK=Yes
  18OPTIONS_SPEC=
  19START_DIR=$(pwd)
  20. git-sh-setup
  21require_work_tree
  22prefix=$(git rev-parse --show-prefix) || exit 1
  23cd_to_toplevel
  24
  25TMP="$GIT_DIR/.git-stash.$$"
  26TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
  27trap 'rm -f "$TMP-"* "$TMPindex"' 0
  28
  29ref_stash=refs/stash
  30
  31if git config --get-colorbool color.interactive; then
  32       help_color="$(git config --get-color color.interactive.help 'red bold')"
  33       reset_color="$(git config --get-color '' reset)"
  34else
  35       help_color=
  36       reset_color=
  37fi
  38
  39no_changes () {
  40        git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
  41        git diff-files --quiet --ignore-submodules -- "$@" &&
  42        (test -z "$untracked" || test -z "$(untracked_files)")
  43}
  44
  45untracked_files () {
  46        if test "$1" = "-z"
  47        then
  48                shift
  49                z=-z
  50        else
  51                z=
  52        fi
  53        excl_opt=--exclude-standard
  54        test "$untracked" = "all" && excl_opt=
  55        git ls-files -o $z $excl_opt -- "$@"
  56}
  57
  58clear_stash () {
  59        if test $# != 0
  60        then
  61                die "$(gettext "git stash clear with parameters is unimplemented")"
  62        fi
  63        if current=$(git rev-parse --verify --quiet $ref_stash)
  64        then
  65                git update-ref -d $ref_stash $current
  66        fi
  67}
  68
  69create_stash () {
  70        stash_msg=
  71        untracked=
  72        while test $# != 0
  73        do
  74                case "$1" in
  75                -m|--message)
  76                        shift
  77                        stash_msg=${1?"BUG: create_stash () -m requires an argument"}
  78                        ;;
  79                -u|--include-untracked)
  80                        shift
  81                        untracked=${1?"BUG: create_stash () -u requires an argument"}
  82                        ;;
  83                --)
  84                        shift
  85                        break
  86                        ;;
  87                esac
  88                shift
  89        done
  90
  91        git update-index -q --refresh
  92        if no_changes "$@"
  93        then
  94                exit 0
  95        fi
  96
  97        # state of the base commit
  98        if b_commit=$(git rev-parse --verify HEAD)
  99        then
 100                head=$(git rev-list --oneline -n 1 HEAD --)
 101        else
 102                die "$(gettext "You do not have the initial commit yet")"
 103        fi
 104
 105        if branch=$(git symbolic-ref -q HEAD)
 106        then
 107                branch=${branch#refs/heads/}
 108        else
 109                branch='(no branch)'
 110        fi
 111        msg=$(printf '%s: %s' "$branch" "$head")
 112
 113        # state of the index
 114        i_tree=$(git write-tree) &&
 115        i_commit=$(printf 'index on %s\n' "$msg" |
 116                git commit-tree $i_tree -p $b_commit) ||
 117                die "$(gettext "Cannot save the current index state")"
 118
 119        if test -n "$untracked"
 120        then
 121                # Untracked files are stored by themselves in a parentless commit, for
 122                # ease of unpacking later.
 123                u_commit=$(
 124                        untracked_files -z "$@" | (
 125                                GIT_INDEX_FILE="$TMPindex" &&
 126                                export GIT_INDEX_FILE &&
 127                                rm -f "$TMPindex" &&
 128                                git update-index -z --add --remove --stdin &&
 129                                u_tree=$(git write-tree) &&
 130                                printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree  &&
 131                                rm -f "$TMPindex"
 132                ) ) || die "$(gettext "Cannot save the untracked files")"
 133
 134                untracked_commit_option="-p $u_commit";
 135        else
 136                untracked_commit_option=
 137        fi
 138
 139        if test -z "$patch_mode"
 140        then
 141
 142                # state of the working tree
 143                w_tree=$( (
 144                        git read-tree --index-output="$TMPindex" -m $i_tree &&
 145                        GIT_INDEX_FILE="$TMPindex" &&
 146                        export GIT_INDEX_FILE &&
 147                        git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
 148                        git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
 149                        git write-tree &&
 150                        rm -f "$TMPindex"
 151                ) ) ||
 152                        die "$(gettext "Cannot save the current worktree state")"
 153
 154        else
 155
 156                rm -f "$TMP-index" &&
 157                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
 158
 159                # find out what the user wants
 160                GIT_INDEX_FILE="$TMP-index" \
 161                        git add--interactive --patch=stash -- "$@" &&
 162
 163                # state of the working tree
 164                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 165                die "$(gettext "Cannot save the current worktree state")"
 166
 167                git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
 168                test -s "$TMP-patch" ||
 169                die "$(gettext "No changes selected")"
 170
 171                rm -f "$TMP-index" ||
 172                die "$(gettext "Cannot remove temporary index (can't happen)")"
 173
 174        fi
 175
 176        # create the stash
 177        if test -z "$stash_msg"
 178        then
 179                stash_msg=$(printf 'WIP on %s' "$msg")
 180        else
 181                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 182        fi
 183        w_commit=$(printf '%s\n' "$stash_msg" |
 184        git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
 185        die "$(gettext "Cannot record working tree state")"
 186}
 187
 188store_stash () {
 189        while test $# != 0
 190        do
 191                case "$1" in
 192                -m|--message)
 193                        shift
 194                        stash_msg="$1"
 195                        ;;
 196                -q|--quiet)
 197                        quiet=t
 198                        ;;
 199                *)
 200                        break
 201                        ;;
 202                esac
 203                shift
 204        done
 205        test $# = 1 ||
 206        die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
 207
 208        w_commit="$1"
 209        if test -z "$stash_msg"
 210        then
 211                stash_msg="Created via \"git stash store\"."
 212        fi
 213
 214        git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
 215        ret=$?
 216        test $ret != 0 && test -z "$quiet" &&
 217        die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
 218        return $ret
 219}
 220
 221push_stash () {
 222        keep_index=
 223        patch_mode=
 224        untracked=
 225        stash_msg=
 226        while test $# != 0
 227        do
 228                case "$1" in
 229                -k|--keep-index)
 230                        keep_index=t
 231                        ;;
 232                --no-keep-index)
 233                        keep_index=n
 234                        ;;
 235                -p|--patch)
 236                        patch_mode=t
 237                        # only default to keep if we don't already have an override
 238                        test -z "$keep_index" && keep_index=t
 239                        ;;
 240                -q|--quiet)
 241                        GIT_QUIET=t
 242                        ;;
 243                -u|--include-untracked)
 244                        untracked=untracked
 245                        ;;
 246                -a|--all)
 247                        untracked=all
 248                        ;;
 249                -m|--message)
 250                        shift
 251                        test -z ${1+x} && usage
 252                        stash_msg=$1
 253                        ;;
 254                --help)
 255                        show_help
 256                        ;;
 257                --)
 258                        shift
 259                        break
 260                        ;;
 261                -*)
 262                        option="$1"
 263                        # TRANSLATORS: $option is an invalid option, like
 264                        # `--blah-blah'. The 7 spaces at the beginning of the
 265                        # second line correspond to "error: ". So you should line
 266                        # up the second line with however many characters the
 267                        # translation of "error: " takes in your language. E.g. in
 268                        # English this is:
 269                        #
 270                        #    $ git stash save --blah-blah 2>&1 | head -n 2
 271                        #    error: unknown option for 'stash save': --blah-blah
 272                        #           To provide a message, use git stash save -- '--blah-blah'
 273                        eval_gettextln "error: unknown option for 'stash save': \$option
 274       To provide a message, use git stash save -- '\$option'"
 275                        usage
 276                        ;;
 277                *)
 278                        break
 279                        ;;
 280                esac
 281                shift
 282        done
 283
 284        eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
 285
 286        if test -n "$patch_mode" && test -n "$untracked"
 287        then
 288                die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
 289        fi
 290
 291        test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
 292
 293        git update-index -q --refresh
 294        if no_changes "$@"
 295        then
 296                say "$(gettext "No local changes to save")"
 297                exit 0
 298        fi
 299
 300        git reflog exists $ref_stash ||
 301                clear_stash || die "$(gettext "Cannot initialize stash")"
 302
 303        create_stash -m "$stash_msg" -u "$untracked" -- "$@"
 304        store_stash -m "$stash_msg" -q $w_commit ||
 305        die "$(gettext "Cannot save the current status")"
 306        say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
 307
 308        if test -z "$patch_mode"
 309        then
 310                if test $# != 0
 311                then
 312                        git reset -q -- "$@"
 313                        git ls-files -z --modified -- "$@" |
 314                        git checkout-index -z --force --stdin
 315                        git clean --force -q -d -- "$@"
 316                else
 317                        git reset --hard -q
 318                fi
 319                test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
 320                if test -n "$untracked"
 321                then
 322                        git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
 323                fi
 324
 325                if test "$keep_index" = "t" && test -n "$i_tree"
 326                then
 327                        git read-tree --reset $i_tree
 328                        git ls-files -z --modified -- "$@" |
 329                        git checkout-index -z --force --stdin
 330                fi
 331        else
 332                git apply -R < "$TMP-patch" ||
 333                die "$(gettext "Cannot remove worktree changes")"
 334
 335                if test "$keep_index" != "t"
 336                then
 337                        git reset -q -- "$@"
 338                fi
 339        fi
 340}
 341
 342save_stash () {
 343        push_options=
 344        while test $# != 0
 345        do
 346                case "$1" in
 347                --)
 348                        shift
 349                        break
 350                        ;;
 351                -*)
 352                        # pass all options through to push_stash
 353                        push_options="$push_options $1"
 354                        ;;
 355                *)
 356                        break
 357                        ;;
 358                esac
 359                shift
 360        done
 361
 362        stash_msg="$*"
 363
 364        if test -z "$stash_msg"
 365        then
 366                push_stash $push_options
 367        else
 368                push_stash $push_options -m "$stash_msg"
 369        fi
 370}
 371
 372have_stash () {
 373        git rev-parse --verify --quiet $ref_stash >/dev/null
 374}
 375
 376list_stash () {
 377        have_stash || return 0
 378        git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
 379}
 380
 381show_stash () {
 382        ALLOW_UNKNOWN_FLAGS=t
 383        assert_stash_like "$@"
 384
 385        if test -z "$FLAGS"
 386        then
 387                if test "$(git config --bool stash.showStat || echo true)" = "true"
 388                then
 389                        FLAGS=--stat
 390                fi
 391
 392                if test "$(git config --bool stash.showPatch || echo false)" = "true"
 393                then
 394                        FLAGS=${FLAGS}${FLAGS:+ }-p
 395                fi
 396
 397                if test -z "$FLAGS"
 398                then
 399                        return 0
 400                fi
 401        fi
 402
 403        git diff ${FLAGS} $b_commit $w_commit
 404}
 405
 406show_help () {
 407        exec git help stash
 408        exit 1
 409}
 410
 411#
 412# Parses the remaining options looking for flags and
 413# at most one revision defaulting to ${ref_stash}@{0}
 414# if none found.
 415#
 416# Derives related tree and commit objects from the
 417# revision, if one is found.
 418#
 419# stash records the work tree, and is a merge between the
 420# base commit (first parent) and the index tree (second parent).
 421#
 422#   REV is set to the symbolic version of the specified stash-like commit
 423#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
 424#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
 425#   s is set to the SHA1 of the stash commit
 426#   w_commit is set to the commit containing the working tree
 427#   b_commit is set to the base commit
 428#   i_commit is set to the commit containing the index tree
 429#   u_commit is set to the commit containing the untracked files tree
 430#   w_tree is set to the working tree
 431#   b_tree is set to the base tree
 432#   i_tree is set to the index tree
 433#   u_tree is set to the untracked files tree
 434#
 435#   GIT_QUIET is set to t if -q is specified
 436#   INDEX_OPTION is set to --index if --index is specified.
 437#   FLAGS is set to the remaining flags (if allowed)
 438#
 439# dies if:
 440#   * too many revisions specified
 441#   * no revision is specified and there is no stash stack
 442#   * a revision is specified which cannot be resolve to a SHA1
 443#   * a non-existent stash reference is specified
 444#   * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
 445#
 446
 447parse_flags_and_rev()
 448{
 449        test "$PARSE_CACHE" = "$*" && return 0 # optimisation
 450        PARSE_CACHE="$*"
 451
 452        IS_STASH_LIKE=
 453        IS_STASH_REF=
 454        INDEX_OPTION=
 455        s=
 456        w_commit=
 457        b_commit=
 458        i_commit=
 459        u_commit=
 460        w_tree=
 461        b_tree=
 462        i_tree=
 463        u_tree=
 464
 465        FLAGS=
 466        REV=
 467        for opt
 468        do
 469                case "$opt" in
 470                        -q|--quiet)
 471                                GIT_QUIET=-t
 472                        ;;
 473                        --index)
 474                                INDEX_OPTION=--index
 475                        ;;
 476                        --help)
 477                                show_help
 478                        ;;
 479                        -*)
 480                                test "$ALLOW_UNKNOWN_FLAGS" = t ||
 481                                        die "$(eval_gettext "unknown option: \$opt")"
 482                                FLAGS="${FLAGS}${FLAGS:+ }$opt"
 483                        ;;
 484                        *)
 485                                REV="${REV}${REV:+ }'$opt'"
 486                        ;;
 487                esac
 488        done
 489
 490        eval set -- $REV
 491
 492        case $# in
 493                0)
 494                        have_stash || die "$(gettext "No stash entries found.")"
 495                        set -- ${ref_stash}@{0}
 496                ;;
 497                1)
 498                        :
 499                ;;
 500                *)
 501                        die "$(eval_gettext "Too many revisions specified: \$REV")"
 502                ;;
 503        esac
 504
 505        case "$1" in
 506                *[!0-9]*)
 507                        :
 508                ;;
 509                *)
 510                        set -- "${ref_stash}@{$1}"
 511                ;;
 512        esac
 513
 514        REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
 515                reference="$1"
 516                die "$(eval_gettext "\$reference is not a valid reference")"
 517        }
 518
 519        i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
 520        set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
 521        s=$1 &&
 522        w_commit=$1 &&
 523        b_commit=$2 &&
 524        w_tree=$3 &&
 525        b_tree=$4 &&
 526        i_tree=$5 &&
 527        IS_STASH_LIKE=t &&
 528        test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
 529        IS_STASH_REF=t
 530
 531        u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
 532        u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
 533}
 534
 535is_stash_like()
 536{
 537        parse_flags_and_rev "$@"
 538        test -n "$IS_STASH_LIKE"
 539}
 540
 541assert_stash_like() {
 542        is_stash_like "$@" || {
 543                args="$*"
 544                die "$(eval_gettext "'\$args' is not a stash-like commit")"
 545        }
 546}
 547
 548is_stash_ref() {
 549        is_stash_like "$@" && test -n "$IS_STASH_REF"
 550}
 551
 552assert_stash_ref() {
 553        is_stash_ref "$@" || {
 554                args="$*"
 555                die "$(eval_gettext "'\$args' is not a stash reference")"
 556        }
 557}
 558
 559apply_stash () {
 560
 561        assert_stash_like "$@"
 562
 563        git update-index -q --refresh || die "$(gettext "unable to refresh index")"
 564
 565        # current index state
 566        c_tree=$(git write-tree) ||
 567                die "$(gettext "Cannot apply a stash in the middle of a merge")"
 568
 569        unstashed_index_tree=
 570        if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
 571                        test "$c_tree" != "$i_tree"
 572        then
 573                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 574                test $? -ne 0 &&
 575                        die "$(gettext "Conflicts in index. Try without --index.")"
 576                unstashed_index_tree=$(git write-tree) ||
 577                        die "$(gettext "Could not save index tree")"
 578                git reset
 579        fi
 580
 581        if test -n "$u_tree"
 582        then
 583                GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
 584                GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
 585                rm -f "$TMPindex" ||
 586                die "$(gettext "Could not restore untracked files from stash entry")"
 587        fi
 588
 589        eval "
 590                GITHEAD_$w_tree='Stashed changes' &&
 591                GITHEAD_$c_tree='Updated upstream' &&
 592                GITHEAD_$b_tree='Version stash was based on' &&
 593                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 594        "
 595
 596        if test -n "$GIT_QUIET"
 597        then
 598                GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 599        fi
 600        if git merge-recursive $b_tree -- $c_tree $w_tree
 601        then
 602                # No conflict
 603                if test -n "$unstashed_index_tree"
 604                then
 605                        git read-tree "$unstashed_index_tree"
 606                else
 607                        a="$TMP-added" &&
 608                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 609                        git read-tree --reset $c_tree &&
 610                        git update-index --add --stdin <"$a" ||
 611                                die "$(gettext "Cannot unstage modified files")"
 612                        rm -f "$a"
 613                fi
 614                squelch=
 615                if test -n "$GIT_QUIET"
 616                then
 617                        squelch='>/dev/null 2>&1'
 618                fi
 619                (cd "$START_DIR" && eval "git status $squelch") || :
 620        else
 621                # Merge conflict; keep the exit status from merge-recursive
 622                status=$?
 623                git rerere
 624                if test -n "$INDEX_OPTION"
 625                then
 626                        gettextln "Index was not unstashed." >&2
 627                fi
 628                exit $status
 629        fi
 630}
 631
 632pop_stash() {
 633        assert_stash_ref "$@"
 634
 635        if apply_stash "$@"
 636        then
 637                drop_stash "$@"
 638        else
 639                status=$?
 640                say "$(gettext "The stash entry is kept in case you need it again.")"
 641                exit $status
 642        fi
 643}
 644
 645drop_stash () {
 646        assert_stash_ref "$@"
 647
 648        git reflog delete --updateref --rewrite "${REV}" &&
 649                say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
 650                die "$(eval_gettext "\${REV}: Could not drop stash entry")"
 651
 652        # clear_stash if we just dropped the last stash entry
 653        git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
 654        clear_stash
 655}
 656
 657apply_to_branch () {
 658        test -n "$1" || die "$(gettext "No branch name specified")"
 659        branch=$1
 660        shift 1
 661
 662        set -- --index "$@"
 663        assert_stash_like "$@"
 664
 665        git checkout -b $branch $REV^ &&
 666        apply_stash "$@" && {
 667                test -z "$IS_STASH_REF" || drop_stash "$@"
 668        }
 669}
 670
 671test "$1" = "-p" && set "push" "$@"
 672
 673PARSE_CACHE='--not-parsed'
 674# The default command is "push" if nothing but options are given
 675seen_non_option=
 676for opt
 677do
 678        case "$opt" in
 679        --) break ;;
 680        -*) ;;
 681        *) seen_non_option=t; break ;;
 682        esac
 683done
 684
 685test -n "$seen_non_option" || set "push" "$@"
 686
 687# Main command set
 688case "$1" in
 689list)
 690        shift
 691        list_stash "$@"
 692        ;;
 693show)
 694        shift
 695        show_stash "$@"
 696        ;;
 697save)
 698        shift
 699        save_stash "$@"
 700        ;;
 701push)
 702        shift
 703        push_stash "$@"
 704        ;;
 705apply)
 706        shift
 707        apply_stash "$@"
 708        ;;
 709clear)
 710        shift
 711        clear_stash "$@"
 712        ;;
 713create)
 714        shift
 715        create_stash -m "$*" && echo "$w_commit"
 716        ;;
 717store)
 718        shift
 719        store_stash "$@"
 720        ;;
 721drop)
 722        shift
 723        drop_stash "$@"
 724        ;;
 725pop)
 726        shift
 727        pop_stash "$@"
 728        ;;
 729branch)
 730        shift
 731        apply_to_branch "$@"
 732        ;;
 733*)
 734        case $# in
 735        0)
 736                push_stash &&
 737                say "$(gettext "(To restore them type \"git stash apply\")")"
 738                ;;
 739        *)
 740                usage
 741        esac
 742        ;;
 743esac